[Leetcode] 0001. 两数之和
1.两数之和
题目描述
给定一个整数数组 nums
和一个整数目标值 target
,请你在该数组中找出 和为目标值 target
的那 两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。
示例 1:
输入:nums = [2,7,11,15], target = 9 输出:[0,1] 解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
示例 2:
输入:nums = [3,2,4], target = 6 输出:[1,2]
示例 3:
输入:nums = [3,3], target = 6 输出:[0,1]
提示:
2 <= nums.length <= 104
-109 <= nums[i] <= 109
-109 <= target <= 109
- 只会存在一个有效答案
进阶:你可以想出一个时间复杂度小于 O(n2)
的算法吗?
解法
方法一:哈希表
我们可以用哈希表(字典) 存放数组值以及对应的下标。
遍历数组 nums
,当发现 target - nums[i]
在哈希表中,说明找到了目标值,返回 target - nums[i]
的下标和 i
即可。
时间复杂度 ,空间复杂度 。其中 是数组 nums
的长度。
Python3
from typing import List
class Solution:
def twoSum(self, nums: List[int], target: int) -> List[int]:
m = {}
for i, x in enumerate(nums):
y = target - x
if y in m:
return [m[y], i]
m[x] = i
fun = Solution()
nums = [2,7,11,15]
target = 9
res = fun.twoSum(nums,target)
print(res)
C++
#include<iostream>
#include<vector>
#include<unordered_map>
using namespace std;
class Solution {
public:
vector<int> twoSum(vector<int>& nums, int target) {
unordered_map<int, int> m;
for (int i = 0; ; ++i) {
int x = nums[i];
int y = target - x;
if (m.count(y)) {
return {m[y], i};
}
m[x] = i;
}
}
};
int main(){
vector<int> nums = {2,7,11,15};
int target = 9;
vector<int> res = Solution().twoSum(nums,target);
cout << res[0] << " " << res[1]<< endl;
return 0;
}
【推荐】国内首个AI IDE,深度理解中文开发场景,立即下载体验Trae
【推荐】编程新体验,更懂你的AI,立即体验豆包MarsCode编程助手
【推荐】抖音旗下AI助手豆包,你的智能百科全书,全免费不限次数
【推荐】轻量又高性能的 SSH 工具 IShell:AI 加持,快人一步
· 全程不用写代码,我用AI程序员写了一个飞机大战
· DeepSeek 开源周回顾「GitHub 热点速览」
· 记一次.NET内存居高不下排查解决与启示
· 物流快递公司核心技术能力-地址解析分单基础技术分享
· .NET10 - 预览版1新功能体验(一)